* Program      : Bld_qry.PRG
* Desc         : Routine to build a query string to be used in
*                locate or filter for adhoc queries
* Notes        : Expects DBF to be open; returns query string
*                using cqrystr passed by reference
* Usage        : cqrystr = ""
*              : DO Bld_qry WITH cqrystr
*              : LOCATE FOR &cqrystr
* From         : TechNotes dBASE IV, April 1991
* Author       : Don Powells
* Minor revisions by David Love
PROCEDURE Bld_qry
PARAMETERS cqrystr
SAVE SCREEN TO qry_scrn
PRIVATE lc_talk, lc_cursor
CLEAR
IF SET("TALK") = "ON"
  SET TALK OFF
  lc_talk = "ON"
ELSE
  lc_talk = "OFF"
ENDIF
lc_cursor = SET("CURSOR")
SET CURSOR OFF

DEFINE WINDOW wqrywin FROM 0,0 TO 23,79 NONE
SET BORDER TO DOUBLE

DEFINE POPUP pufield FROM 6,1 TO 17,16 ;
  PROMPT STRUCTURE ;
  MESSAGE "Select a field name or press <Esc> to abort"
ON SELECTION POPUP pufield DEACTIVATE POPUP

DEFINE POPUP puops FROM 6,23 ;
  MESSAGE "Select an operator"
DEFINE BAR 1 OF puops PROMPT "Equal"
DEFINE BAR 2 OF puops PROMPT "Not Equal"
DEFINE BAR 3 OF puops PROMPT "Less Than"
DEFINE BAR 4 OF puops PROMPT "Less Than or Equal"
DEFINE BAR 5 OF puops PROMPT "Greater Than"
DEFINE BAR 6 OF puops PROMPT "Greater Than or Equal  "
ON SELECTION POPUP puops DEACTIVATE POPUP

DEFINE POPUP pucon FROM 15,23 TO 19,45 ;
  MESSAGE "Select a connector or choose DONE"
DEFINE BAR 1 OF pucon PROMPT "DONE"
DEFINE BAR 2 OF pucon PROMPT "AND"
DEFINE BAR 3 OF pucon PROMPT "OR"
ON SELECTION POPUP pucon DEACTIVATE POPUP

DEFINE WINDOW wdata FROM 10,0 TO 12,79 DOUBLE
ACTIVATE WINDOW wqrywin

DO Saycenter WITH 2,80,"BUILD QUERY EXPRESSION"
@ 5,1 SAY "Field Names"
@ 5,23 SAY "Operators"
@ 14,23 SAY "Connectors"
@ 5,50 SAY "Dbf Name"
@ 6,50 TO 6,59
@ 7,50 SAY UPPER(DBF())
SHOW POPUP pufield
SHOW POPUP puops
SHOW POPUP pucon
@ 21,0 to 21,79
DO Saycenter WITH 21,80,"<Expression>"

cqrystr = ""
kESC = 27
nfldbar = 0
nopsbar = 0
nconbar = 0
DECLARE opsary[6]
opsary[1] = "="
opsary[2] = "<>"
opsary[3] = "<"
opsary[4] = "<="
opsary[5] = ">"
opsary[6] = ">="

DO WHILE .T.
  ACTIVATE POPUP pufield
  nfldbar = BAR()
  ccurfld = PROMPT()
  ccurtype = TYPE(ccurfld)
  IF LASTKEY() = 27
    EXIT
  ELSE
    cqrystr = cqrystr + IIF("" = cqrystr,""," ") + ccurfld
  ENDIF
  @ 22,0 SAY cqrystr

  DO WHILE .T.
    ACTIVATE POPUP puops
    nopsbar = BAR()
    coperator = IIF(nopsbar = 0,"",opsary[nopsbar])
    IF LASTKEY() = kESC
      EXIT
    ELSE
      IF ccurtype = "L" .AND. nopsbar <> 1 .AND. nopsbar <> 2
        DO Warnbeep
        LOOP
      ELSE
        cqrystr = cqrystr + " " + coperator
        EXIT
      ENDIF
    ENDIF
  ENDDO
  IF LASTKEY() = kESC
    EXIT
  ENDIF
  @ 22,0 say cqrystr

  DO CASE
    CASE ccurtype = "C"
      getvar = SPACE(LEN(&ccurfld))
    CASE ccurtype = "N"
      getvar = 0.00
    CASE ccurtype = "D"
      getvar = DATE()
    CASE ccurtype = "L"
      getvar = .T.
    OTHERWISE
      getvar = ""
  ENDCASE

  ACTIVATE WINDOW wdata
  @ 0,1 SAY "Enter "+TRIM(ccurfld)+":" ;
    GET getvar ;
    PICTURE get_pic(ccurfld)
  SET CURSOR ON
  READ
  SET CURSOR OFF
  DEACTIVATE WINDOW wdata
  IF LASTKEY() = kESC
    EXIT
  ELSE
    DO CASE
      CASE ccurtype = "C"
        cqrystr=cqrystr+" '"+TRIM(getvar)+"'"
      CASE ccurtype = "N"
        cqrystr=cqrystr+" "+LTRIM(STR(getvar))
      CASE ccurtype = "L"
        cqrystr=cqrystr+" "+IIF(getvar,".T.",".F.")
      CASE ccurtype = "D"
        cqrystr=cqrystr+" CTOD('"+DTOC(getvar)+"')"
    ENDCASE
    @ 22,0 SAY cqrystr
  ENDIF

  ACTIVATE POPUP pucon
  nconbar = BAR()
  ccuron = PROMPT()

  DO CASE
    CASE LASTKEY() = kESC
      EXIT
    CASE ccuron = "AND"
      ccuron = ".AND."
    CASE ccuron = "OR"
      ccuron = ".OR."
    CASE ccuron = "DONE"
      EXIT
  ENDCASE
  cqrystr = cqrystr+" "+ccuron
  @ 22,0 SAY cqrystr
ENDDO
IF LASTKEY() = kESC
  cqrystr = ""
ENDIF
DEACTIVATE WINDOW wqrywin
RESTORE SCREEN FROM qry_scrn
RELEASE SCREEN qry_scrn
RELEASE WINDOWS wqrywin,wdata
RELEASE POPUPS pufield,puops,pucon
SET CURSOR &lc_cursor
SET TALK &lc_talk
RETURN
* EOP: Bld_qry.PRG

FUNCTION get_pic
  PARAMETERS cfield
  PRIVATE cretval, cstring
  cstring = SPACE(20)
  DO CASE
    CASE TYPE(cfield) = "C"
      cretval = "@S"+LTRIM(STR(MIN(LEN(&cfield),59)))
    CASE TYPE(cfield) = "N"
      cretval = STR(&cfield)
      IF "." $ cstring
        cretval = REPLICATE("9",AT(".",cstring) - 1) + "."
        cretval = cretval + REPLICATE("9",;
          LEN(cstring) - LEN(cstring))
      ELSE
        cretval = REPLICATE("9",LEN(cstring))
      ENDIF
    OTHERWISE
      cretval = ""
  ENDCASE
RETURN (cretval)
* EOP: Get_pic()

PROCEDURE Saycenter
  PARAMETERS nrow, ndispwidth, cstring
  ncol = (ndispwidth - LEN(cstring)) / 2
  ncol = IIF(ncol<0,0,ncol)
  @ nrow,ncol SAY cstring
RETURN
*EOP: Saycenter

PROCEDURE Tone
  PARAMETERS freq, dura
  SET BELL TO freq, dura
  ?? CHR(7)
RETURN
*EOP: Tone

PROCEDURE Warnbeep
  mfreq = 300
  mdura = 3
  mfreq2 = 50
  mdura2 = 4.5
  DO Tone WITH mfreq, mdura
  DO Tone WITH mfreq2, mdura2
RETURN
*EOP: Warnbeep

